import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["design", "href", "icon", "iconPlacement", "onClick", "responsive", "size", "type", "readOnly", "disabled", "isFitted"];
import cx from 'classnames';
import PropTypes from 'prop-types';
import ActionableTag from './Actionable/index.js';
import { DESIGNS, getActionableProps, getStandardProps, LINK_TYPES, SIZES } from './constants.js';
import StandardTag from './Standard.js';
import { jsx as _jsx } from "react/jsx-runtime";
var AtomTag = function AtomTag(_ref) {
  var design = _ref.design,
    href = _ref.href,
    icon = _ref.icon,
    _ref$iconPlacement = _ref.iconPlacement,
    iconPlacement = _ref$iconPlacement === void 0 ? 'left' : _ref$iconPlacement,
    onClick = _ref.onClick,
    responsive = _ref.responsive,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? SIZES.MEDIUM : _ref$size,
    type = _ref.type,
    readOnly = _ref.readOnly,
    disabled = _ref.disabled,
    _ref$isFitted = _ref.isFitted,
    isFitted = _ref$isFitted === void 0 ? false : _ref$isFitted,
    props = _objectWithoutPropertiesLoose(_ref, _excluded);
  var isActionable = onClick || href;
  var _ref2 = isActionable ? [ActionableTag, getActionableProps] : [StandardTag, getStandardProps],
    Component = _ref2[0],
    getter = _ref2[1];
  return /*#__PURE__*/_jsx(Component, _extends({}, getter(_extends({
    design: design,
    href: href,
    icon: icon,
    iconPlacement: iconPlacement,
    onClick: onClick,
    responsive: responsive,
    size: size,
    type: type,
    readOnly: readOnly,
    disabled: disabled,
    isFitted: isFitted
  }, props)), {
    disabled: disabled,
    readOnly: readOnly,
    className: cx('sui-AtomTag', "sui-AtomTag--size-" + size, design && "sui-AtomTag--design-" + design, icon && 'sui-AtomTag-hasIcon', responsive && 'sui-AtomTag--responsive', type && "sui-AtomTag--type-" + type, isFitted && 'sui-AtomTag--isFitted')
  }));
};
AtomTag.displayName = 'AtomTag';
export default AtomTag;
export { DESIGNS as atomTagDesigns };
export { LINK_TYPES as linkTypes };
export { LINK_TYPES as atomTagLinkTypes };
export { SIZES as atomTagSizes };